package BoidGui;
import java.awt.*;
import java.util.ArrayList;
import java.util.Random;


/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author TALAL ALANIZI
 */
public class BoidFlock {

    public int detectradius =100;
    public static final int BOARDS = 300;
    private RandomObtainable<Boid> boids;

    public BoidFlock() {
        boids = new RandomObtainable<>();
    }

    public BoidFlock(int numBoidsToStart) {
        boids = new RandomObtainable<>();
        for (int i = 0; i < numBoidsToStart; i++) {
            addBoidToFlock();
        }
    }

    public void addBoidToFlock() {
        Boid boid = new Boid(this, new Random().nextInt(BOARDS), new Random().nextInt(BOARDS), Boid.MAX_SPEED, Boid.MAX_SPEED, BOARDS, BOARDS);
        boids.insertRandom(boid);
        new Thread(boid).start();
    }

    public void drawAllBoids(Graphics g) {
        for (Boid boid : boids) {
            boid.drawShip(g);
        }
    }

    public void removeBoidFromFlock(){
        Boid boid=boids.get(new Random().nextInt(boids.size()));
        boid.stopRequested=true;
        boids.remove(boid);             //removeRandom will not stop thread
    }

    public int getNumberOfBoids(){
        return boids.size();
    }

    public void destroyAllBoids(){
        for (Boid boid : boids) {
            boid.stopRequested=true;
        }
        boids.clear();
    }

    public ArrayList<Boid> getNeighbours(Boid boid) {
        ArrayList<Boid> neighbours = new ArrayList<>();
        for (Boid boid1 : boids) {
            if (boid1.equals(boid)) continue;
            if (Math.pow((boid1.getxPos()-boid.getxPos()),2)+Math.pow((boid1.getyPos()-boid.getyPos()),2)< detectradius){
                neighbours.add(boid1);
            }
        }
        return neighbours;
    }

    public int getDetectradius() {
        return detectradius;
    }

    public void setDetectradius(int detectradius) {
        this.detectradius = detectradius;
    }
}
